'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _last2 = require('lodash/last');

var _last3 = _interopRequireDefault(_last2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _without2 = require('lodash/without');

var _without3 = _interopRequireDefault(_without2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compose = require('../../utils/compose');

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Dropdown = require('../Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _SearchTerm = require('./_SearchTerm');

var _SearchTerm2 = _interopRequireDefault(_SearchTerm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TermsContainer = _styledComponents2.default.ul.withConfig({
  displayName: 'Search__TermsContainer'
})(['list-style:none;display:flex;margin:0;padding:0;flex-wrap:wrap;']);

var Icon = _styledComponents2.default.i.withConfig({
  displayName: 'Search__Icon'
})(['padding:10px 8px 10px 10px;']);

var SearchInput = _styledComponents2.default.div.withConfig({
  displayName: 'Search__SearchInput'
})(['display:flex;flex-wrap:wrap;flex:3;width:100%;']);

var Styled = function Styled(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'Search'
  })(['position:relative;display:flex;background-color:', ';border:1px solid ', ';border-radius:', ';font-size:', ';div,input{border:0;}', ',', '{padding:0;margin:0;}', '{flex:1;line-height:36px;border-left:1px solid ', ';.dropdown-popover{width:auto;}}', '{flex:2;width:100%;input{padding:0 8px;width:100%;}input:focus{outline:none;}div{margin:0;}}'], function (props) {
    return props.theme.colors.white;
  }, function (props) {
    return props.theme.colors.purple100;
  }, function (props) {
    return props.theme.borderRadius.soft;
  }, function (props) {
    return props.theme.fontSizes.small;
  }, _Input2.default, _Dropdown2.default, _Dropdown2.default, function (props) {
    return props.theme.colors.gray200;
  }, _Input2.default);
};

var Search = function (_React$PureComponent) {
  _inherits(Search, _React$PureComponent);

  function Search() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Search);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Search.__proto__ || Object.getPrototypeOf(Search)).call.apply(_ref, [this].concat(args))), _this), _this.addSearchTerm = function (value) {
      var nextPinnedTerms = _this.props.pinnedTerms;
      // only push unique values
      if (!(0, _includes3.default)(nextPinnedTerms, value)) {
        nextPinnedTerms = [].concat(_toConsumableArray(nextPinnedTerms), [value]);
        _this.props.onPin(nextPinnedTerms);
      }
      _this.props.onChange('', nextPinnedTerms);
    }, _this.removeSearchTerm = function (value) {
      var nextPinnedTerms = (0, _without3.default)(_this.props.pinnedTerms, value);
      _this.props.onChange(_this.props.query, nextPinnedTerms);
    }, _this.handleInputKeyPress = function (ev) {
      if (ev.key === 'Enter' && _this.props.query.length > 0) {
        ev.preventDefault();
        _this.addSearchTerm(_this.props.query);
      } else if (ev.key === 'Backspace' && _this.props.query === '') {
        ev.preventDefault();
        var term = (0, _last3.default)(_this.props.pinnedTerms);
        if (term) {
          // Allow the user to edit the text of the last term instead of removing the whole thing.
          _this.removeSearchTerm(term);
        }
      }
    }, _this.handleInputChange = function (ev) {
      _this.props.onChange(ev.target.value, _this.props.pinnedTerms);
    }, _this.handleInputBlur = function (ev) {
      // If the input loses focus, pin the search term. Skip if input is empty.
      if (_this.props.query) {
        _this.addSearchTerm(_this.props.query);
      }
      _this.props.onBlur(ev);
    }, _this.handleFilterChange = function (ev, value) {
      _this.input.focus();
      _this.props.onFilterSelect(value);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Search, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          filters = _props.filters,
          placeholder = _props.placeholder,
          query = _props.query,
          pinnedTerms = _props.pinnedTerms;


      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(Icon, { className: 'fa fa-search' }),
        _react2.default.createElement(
          SearchInput,
          null,
          _react2.default.createElement(
            TermsContainer,
            null,
            (0, _map3.default)(pinnedTerms, function (term) {
              return _react2.default.createElement(_SearchTerm2.default, { key: term, term: term, onRemove: _this2.removeSearchTerm });
            })
          ),
          _react2.default.createElement(_Input2.default, {
            hideValidationMessage: true,
            onChange: this.handleInputChange,
            value: query,
            onKeyDown: this.handleInputKeyPress,
            onBlur: this.handleInputBlur,
            onFocus: this.props.onFocus,
            inputRef: function inputRef(ref) {
              _this2.input = ref;
            },
            placeholder: pinnedTerms.length === 0 ? placeholder : null
          })
        ),
        !(0, _isEmpty3.default)(filters) && _react2.default.createElement(_Dropdown2.default, {
          items: filters,
          placeholder: 'Filters',
          onChange: this.handleFilterChange
        })
      );
    }
  }]);

  return Search;
}(_react2.default.PureComponent);

Search.propTypes = {
  /**
   * The initial value to use to populate the search text field.
   * Changes to this prop will be ignored after initial render.
   */
  query: _propTypes2.default.string.isRequired,
  /**
   * The initial pinned terms of the search field.
   * Changes to this prop will be ignored after initial render.
   */
  pinnedTerms: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
  /**
   * Handler that runs when the text input changes.
   * Returns the text as first argument, and the list of pinned terms as the second.
   */
  onChange: _propTypes2.default.func.isRequired,
  /**
   * A list of selectable filters to be rendered in a `<Dropdown />`.
   * When an option is clicked, the `value` is added to the search terms.
   * This array will be passed directly to the `items` prop of the `<Dropdown />.
   * If omitted, no dropdown will be rendered.
   */
  filters: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.string,
    label: _propTypes2.default.string
  })),
  /**
   * Text that will be passed to the search input as the placeholder.
   */
  placeholder: _propTypes2.default.string,
  /**
   * Handler that runs when a search is pinned or unpinned.
   * Returns an array of the currently pinned terms.
   */
  onPin: _propTypes2.default.func,
  /**
   * Handler that runs when an item from the search filter dropdown is selected
   * Returns the selected filter value.
   */
  onFilterSelect: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func
};

Search.defaultProps = {
  placeholder: '',
  filters: [],
  onPin: _noop3.default,
  onFilterSelect: function onFilterSelect() {
    throw new Error('Please provide an onFilterSelect(value) callback!');
  },
  onFocus: _noop3.default,
  onBlur: _noop3.default
};

exports.default = (0, _compose.copyPropTypes)(Search, Styled(Search));